/*
 * The integration developer needs to create the method processData 
 * This method takes Message object of package com.sap.gateway.ip.core.customdev.util
 * which includes helper methods useful for the content developer:
 * 
 * The methods available are:
    public java.lang.Object getBody()
    
    //This method helps User to retrieve message body as specific type ( InputStream , String , byte[] ) - e.g. message.getBody(java.io.InputStream)
    public java.lang.Object getBody(java.lang.String fullyQualifiedClassName)

    public void setBody(java.lang.Object exchangeBody)

    public java.util.Map<java.lang.String,java.lang.Object> getHeaders()

    public void setHeaders(java.util.Map<java.lang.String,java.lang.Object> exchangeHeaders)

    public void setHeader(java.lang.String name, java.lang.Object value)

    public java.util.Map<java.lang.String,java.lang.Object> getProperties()

    public void setProperties(java.util.Map<java.lang.String,java.lang.Object> exchangeProperties) 

	public void setProperty(java.lang.String name, java.lang.Object value)
 * 
 */
import com.sap.gateway.ip.core.customdev.util.Message;
import java.util.HashMap;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.TimeZone;

def synchronized Message processData(Message message) {
	
	
	SimpleDateFormat dateFormat = new SimpleDateFormat("yyyyMMddHHmmssZ");
	Date date = new Date();
	dateFormat.setTimeZone(TimeZone.getTimeZone("IST"));
	
	//get the clientid  
	def headers = message.getHeaders();
	
	
	//get the txn and gstin
	properties = message.getProperties();
	txn = properties.get("txn");
	api_action = properties.get("action");
	clientid = properties.get("clientid");
	custid = properties.get("custid");
	client_secret = properties.get("client-secret");
	
	if("COMM".equals(properties.get("api_action")) || "RETTRACK".equals(api_action)){
		gstin = properties.get("comm_gstin");
	}else{
		gstin = properties.get("gstin");
	}
	
	StringBuilder sb = new StringBuilder();
	
	//create the X-Asp-Auth-Token string

	sb.append("v2.0:");
	/*if(custid == null || custid.trim().isEmpty()){
		sb.append("").append(":");
		message.setHeader("clientid",clientid);
	    message.setHeader("client-secret",client_secret);
	   // message.setHeader("custid",custid);
		
	}else{
		sb.append(custid).append(":");
	}
	vayana_auth_token = sb.append(clientid).append(":").append(txn).append(":").append(dateFormat.format(date)).append(":").append(gstin).append(":").append(api_action);
	*/
	
	
	
	
	
	
	if(custid == null || custid.trim().isEmpty() ){
		sb.append("").append(":");
	    vayana_auth_token = sb.append(clientid).append(":").append(txn).append(":").append(dateFormat.format(date)).append(":").append(gstin).append(":").append(api_action);
	    
	    	message.setHeader("clientid",clientid);
	    	message.setHeader("client-secret",client_secret);
	    
	}else{
		sb.append(custid).append("::");
		vayana_auth_token = sb.append(txn).append(":").append(dateFormat.format(date)).append(":").append(gstin).append(":").append(api_action);
	}
	
	//vayana_auth_token = sb.append(clientid).append(":").append(txn).append(":").append(dateFormat.format(date)).append(":").append(gstin).append(":").append(api_action);
	
	
	
	
	// set the auth token for Vayana GSP
	message.setHeader("X-Asp-Auth-Token",vayana_auth_token);
	message.setProperty("X-Asp-Auth-Token",vayana_auth_token);
	
	//Body 
	def body = message.getBody();
	message.setBody(vayana_auth_token);

	return message;
}

