/**
 * This script is used to handle the response received from GSP/GSTN system
 * 
 * Date		  |	Information
 * ------------------------------------------------------------------------ 
 * 13-08-2017 | Initial Version
 */


import com.sap.gateway.ip.core.customdev.util.Message;

import groovy.json.JsonSlurper
import groovy.json.JsonBuilder

import java.security.NoSuchAlgorithmException

import javax.crypto.Cipher
import javax.crypto.NoSuchPaddingException
import javax.crypto.ShortBufferException
import javax.crypto.spec.SecretKeySpec
import javax.xml.bind.DatatypeConverter

import javax.crypto.Mac;

import java.util.zip.ZipEntry;
import org.apache.commons.compress.compressors.gzip.*;
import org.apache.commons.io.IOUtils;
import org.apache.commons.compress.archivers.tar.*;
import java.io.BufferedReader;
import java.io.InputStreamReader;

def Message processData(Message message) {

	//Body

	def map = message.getProperties();
	def headers = message.getHeaders();
	String enckey = map.get("enckey");
//	String enckey = "f2jLSJGGxaRfH3F1j/bjTrajR7/+SiYIGST3Qd67UBw=";
	map.put("enckey",enckey);
	
	



				def inputStream = message.getBody(InputStream.class);
				def jsonString = new JsonBuilder();
				GzipCompressorInputStream gzipStream = new GzipCompressorInputStream(inputStream);
				TarArchiveInputStream tarStream = new TarArchiveInputStream(gzipStream);
				TarArchiveEntry tarEntry = tarStream.getNextTarEntry();
				BufferedReader bufReader = null;
				//TarArchiveEntry tarEntry = null;
				StringBuffer sbuffer = new StringBuffer();
	            	map.put("enckey11",enckey);
				while(tarEntry != null)
				{
					if(tarEntry.isDirectory())
					{
					   	map.put("enckey1",enckey);
					    
					     while ((tarEntry = tarStream.getNextTarEntry()) != null) {
					        if (!tarEntry.isDirectory()) {
					             bufReader = new BufferedReader(new InputStreamReader(tarStream));
					             	while(bufReader.ready())
					            	{
							            sbuffer.append(bufReader.readLine());
						            }
						            
					            
					        }
					         
					     }
					     
					    String data = new String(symmDecryption(enckey.decodeBase64(), sbuffer.toString()).decodeBase64());
						jsonString	status_cd: "1",
						data: data
						message.setBody(jsonString.toString());
						// Interested only in files, Directories to be skipped
					}
					else
					{
					   	map.put("enckey2",enckey);
						InputStreamReader instreamReader = new InputStreamReader(tarStream);
						bufReader = new BufferedReader(instreamReader);
						while(bufReader.ready())
						{
							sbuffer.append(bufReader.readLine());
						}
					
					//	String enckey = map.get("enckey");
						String data = new String(symmDecryption(enckey.decodeBase64(), sbuffer.toString()).decodeBase64());
						jsonString	status_cd: "1",
						data: data
						message.setBody(jsonString.toString());
					}
					tarEntry = tarStream.getNextTarEntry();
				}

	map.put("enckey4",enckey);
	// calculate the time difference


	return message;
}


def synchronized String symmDecryption(byte[] key, String data){

	//constants
	String AES_TRANSFORMATION = "AES/ECB/PKCS5Padding";
	String AES_ALGORITHM = "AES";
	ENC_BITS = 256;
	
	try {
		decryptCipher = Cipher.getInstance(AES_TRANSFORMATION);
	} catch (NoSuchAlgorithmException | NoSuchPaddingException e1) {
		return null;
	}
	SecretKeySpec secreteKey = new SecretKeySpec(key, AES_ALGORITHM);
	decryptCipher.init(Cipher.DECRYPT_MODE, secreteKey);
	
	InputStream instream = new ByteArrayInputStream(DatatypeConverter.parseBase64Binary(data));
	OutputStream outStream = new ByteArrayOutputStream();
	
	final int cipherBlockSize = decryptCipher.getBlockSize();
	final int outBlockSize = decryptCipher.getOutputSize(cipherBlockSize);
	
	final byte[] inData = new byte[cipherBlockSize];
	byte[] outData = new byte[outBlockSize];
	
	int inReadSize = 0;
	
	try
	{
		while((inReadSize % cipherBlockSize == 0))
		{
			inReadSize = instream.read(inData);
			if(inReadSize == cipherBlockSize)
			{
				try {
					final int encryptedLength = decryptCipher.update(inData, 0, inReadSize,outData);
					outStream.write(outData, 0, encryptedLength);
				} catch (ShortBufferException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
					return null;
				}
	
			}
		}
	
		if(inReadSize > 0)
		{
			outData = decryptCipher.doFinal(inData,0,inReadSize);
		}
		else
		{
			outData = decryptCipher.doFinal();
		}
	
		outStream.write(outData);
		byte[] decryptedData = ((ByteArrayOutputStream)outStream).toByteArray();
		return decryptedData.encodeBase64().toString();
	}
	finally
	{
		try
		{
			instream.close();
		}
		catch(IOException exception)
		{
			exception.printStackTrace();
		}
		try
		{
			outStream.close();
		}
		catch(IOException exception)
		{
			exception.printStackTrace();
		}
	}
}

def String generateHmac(byte[] key, String data){
	try{
		Mac sha256_HMAC = Mac.getInstance("HmacSHA256");
		SecretKeySpec secret_key = new SecretKeySpec(key, "AES");
		sha256_HMAC.init(secret_key);
	
		String hash = sha256_HMAC.doFinal(data.getBytes()).encodeBase64().toString();
		return hash;
	}catch(Exception e){
		return "";
	}
}